// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from robot_calibration_msgs:msg/ExtendedCameraInfo.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "robot_calibration_msgs/msg/extended_camera_info.hpp"


#ifndef ROBOT_CALIBRATION_MSGS__MSG__DETAIL__EXTENDED_CAMERA_INFO__TRAITS_HPP_
#define ROBOT_CALIBRATION_MSGS__MSG__DETAIL__EXTENDED_CAMERA_INFO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "robot_calibration_msgs/msg/detail/extended_camera_info__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'camera_info'
#include "sensor_msgs/msg/detail/camera_info__traits.hpp"
// Member 'parameters'
#include "robot_calibration_msgs/msg/detail/camera_parameter__traits.hpp"

namespace robot_calibration_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ExtendedCameraInfo & msg,
  std::ostream & out)
{
  out << "{";
  // member: camera_info
  {
    out << "camera_info: ";
    to_flow_style_yaml(msg.camera_info, out);
    out << ", ";
  }

  // member: parameters
  {
    if (msg.parameters.size() == 0) {
      out << "parameters: []";
    } else {
      out << "parameters: [";
      size_t pending_items = msg.parameters.size();
      for (auto item : msg.parameters) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ExtendedCameraInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: camera_info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "camera_info:\n";
    to_block_style_yaml(msg.camera_info, out, indentation + 2);
  }

  // member: parameters
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.parameters.size() == 0) {
      out << "parameters: []\n";
    } else {
      out << "parameters:\n";
      for (auto item : msg.parameters) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ExtendedCameraInfo & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace robot_calibration_msgs

namespace rosidl_generator_traits
{

[[deprecated("use robot_calibration_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const robot_calibration_msgs::msg::ExtendedCameraInfo & msg,
  std::ostream & out, size_t indentation = 0)
{
  robot_calibration_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use robot_calibration_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const robot_calibration_msgs::msg::ExtendedCameraInfo & msg)
{
  return robot_calibration_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<robot_calibration_msgs::msg::ExtendedCameraInfo>()
{
  return "robot_calibration_msgs::msg::ExtendedCameraInfo";
}

template<>
inline const char * name<robot_calibration_msgs::msg::ExtendedCameraInfo>()
{
  return "robot_calibration_msgs/msg/ExtendedCameraInfo";
}

template<>
struct has_fixed_size<robot_calibration_msgs::msg::ExtendedCameraInfo>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<robot_calibration_msgs::msg::ExtendedCameraInfo>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<robot_calibration_msgs::msg::ExtendedCameraInfo>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ROBOT_CALIBRATION_MSGS__MSG__DETAIL__EXTENDED_CAMERA_INFO__TRAITS_HPP_
